#include "bonus.h"
#include "sound.h"
#include "player.h"
#include "bitmap.h"
#include "coll.h"
#include "random.h"

extern SPR_ATTR attr[];
extern PLAYER Players[];


#define N_BONUS 5
BONUS Bonuss[N_BONUS];

void bonuss_init(){
  int i;
  for (i=0;i<N_BONUS;i++){
    Bonuss[i].active = 1;
    Bonuss[i].pos[X] = toFIXED(minmaxrndint(0,X_MAX) - X_MAX/2);
    Bonuss[i].pos[Y] = toFIXED(minmaxrndint(0,Y_MAX) - Y_MAX/2);
    Bonuss[i].type = minmaxrndint(bt_life,bt_last-1);
    Bonuss[i].zoom = minmaxrnd(toFIXED(0.3),toFIXED(1.0));
  }
}
void bonuss_step(){
}


void bonus_display(BONUS* b){

  static ANGLE ang = DEGtoANG(0.0);
  //  ang += DEGtoANG(1.0);

  static FIXED post[] = {toFIXED(0.0),toFIXED(0.0),toFIXED(169.0),toFIXED(0.5)};
  post[X] = b->pos[X];
  post[Y] = b->pos[Y];
  //  post[3] = toFIXED(1.0);

  b->zoom = b->zoom + toFIXED(0.01);
  if (b->zoom>toFIXED(1.0)) b->zoom = toFIXED(0.3);
  post[S] = b->zoom;

  int spr_num = 0;
  switch (b->type){
  case bt_life:
    spr_num=25;
    break;
  case bt_mine :
    spr_num=32;
    break;
  case bt_last :
    break;
  }

  slDispSprite(post, (SPR_ATTR *)(&attr[spr_num].texno), ang);   
}

void bonuss_display(){
  int i;
  for (i=0;i<N_BONUS;i++){
    if (Bonuss[i].active)
      bonus_display(&(Bonuss[i]));
  }
}
void bonuss_check_players(){
  int i,j;
  for (i=0;i<N_BONUS;i++){
    for (j=0;j<PLAYER_NUM;j++){
      if (Players[j].plays){
	int coll=0;
	if (Bonuss[i].active){
	  if (Players[j].is_infant){
	  coll = circle_collide(Bonuss[i].pos,Players[j].infant.pos,toFIXED(7.0));
	  } else {
	    coll = circle_collide(Bonuss[i].pos,Players[j].pos,toFIXED(12.0));
	  }
	  if (coll) {
	    Bonuss[i].active = 0;
	    switch (Bonuss[i].type){
	    case bt_life:
	      Players[j].energy = Players[j].energy + (MAX_PLAYER_ENERGY-Players[j].energy)/3;
	      break;
	    case bt_mine :
	      Players[j].energy = (Players[j].energy*3/4);
	      break;
	    case bt_last :
	      break;
	    }
	  }
	}
      }
    }
  }
}
