#include "coll.h"
#include "trigolo.h"


int circle_collide(FIXED pi[XY], FIXED pj[XY], FIXED dmax){
  
  //  slBMLine(pi[X]>>16,pi[Y]>>16,pj[X]>>16,pj[Y]>>16,minmaxrndint(0,10));
  
  FIXED dist[XY];
  dist[X] = pi[X] - pj[X];
  dist[Y] = pi[Y] - pj[Y];

  if ((dist[X]>(dmax))) return 0;
  if ((dist[X]<(-dmax))) return 0;

  if ((dist[Y]>(dmax))) return 0;
  if ((dist[Y]<(-dmax))) return 0;

  FIXED real = slSquartFX(slMulFX(dist[X],dist[X])+slMulFX(dist[Y],dist[Y]));

  if (real>dmax) return 0;

  return 1;  
}



// p : point / repère player -> res point / repère écran
void coord_player_to_screen(FIXED p[XY],FIXED t[XY], ANGLE a, FIXED res[XY]){   
  FIXED sina = sinus(a);
  FIXED cosa = cosinus(a);
  res[X] = slMulFX(p[X],cosa) - slMulFX(p[Y],sina) + t[X];
  res[Y] = slMulFX(p[X],sina) + slMulFX(p[Y],cosa) + t[Y];
}

// p : point /  repère écran -> res point /repère player
void coord_screen_to_player(FIXED p[XY],FIXED t[XY], ANGLE a, FIXED res[XY]){   
  FIXED sina = sinus(a);
  FIXED cosa = cosinus(a);
  FIXED dX = p[X] - t[X];
  FIXED dY = p[Y] - t[Y];
  res[Y] = slMulFX(-dX,sina)+slMulFX(dY,cosa);
  res[X] = slMulFX(dX,cosa)+slMulFX(dY,sina);
}

int rect_collide(FIXED pos1[XY],FIXED ang1,FIXED l1[XY],FIXED pos2[XY],FIXED ang2,FIXED l2[XY]){
  int i;
  int coll = 0;


  FIXED s1_1[4][XY];
  s1_1[0][X] = slMulFX(toFIXED(0.5),l1[X]);
  s1_1[0][Y] = slMulFX(toFIXED(0.5),l1[Y]);
  s1_1[1][X] = slMulFX(toFIXED(0.5),l1[X]);
  s1_1[1][Y] = slMulFX(toFIXED(-0.5),l1[Y]);
  s1_1[2][X] = slMulFX(toFIXED(-0.5),l1[X]);
  s1_1[2][Y] = slMulFX(toFIXED(-0.5),l1[Y]);
  s1_1[3][X] = slMulFX(toFIXED(-0.5),l1[X]);
  s1_1[3][Y] = slMulFX(toFIXED(0.5),l1[Y]);

  FIXED s2_2[4][XY];
  s2_2[0][X] = slMulFX(toFIXED(0.5),l2[X]);
  s2_2[0][Y] = slMulFX(toFIXED(0.5),l2[Y]);
  s2_2[1][X] = slMulFX(toFIXED(0.5),l2[X]);
  s2_2[1][Y] = slMulFX(toFIXED(-0.5),l2[Y]);
  s2_2[2][X] = slMulFX(toFIXED(-0.5),l2[X]);
  s2_2[2][Y] = slMulFX(toFIXED(-0.5),l2[Y]);
  s2_2[3][X] = slMulFX(toFIXED(-0.5),l2[X]);
  s2_2[3][Y] = slMulFX(toFIXED(0.5),l2[Y]);

  FIXED s1_0[4][XY];
  FIXED s1_2[4][XY];
 
  for (i=0;i<4;i++){
    coord_player_to_screen(s1_1[i],pos1,ang1,s1_0[i]);
    coord_screen_to_player(s1_0[i],pos2,ang2,s1_2[i]);
    coll = ( (s1_2[i][X]<s2_2[0][X])
	     && (s1_2[i][X]>s2_2[2][X])
	     && (s1_2[i][Y]<s2_2[0][Y])
	     && (s1_2[i][Y]>s2_2[2][Y]));
    if (coll) break;
  }
  

  FIXED s2_0[4][XY];
  FIXED s2_1[4][XY];
  if (!coll){
    for (i=0;i<4;i++){
      coord_player_to_screen(s2_2[i],pos2,ang2,s2_0[i]);
      coord_screen_to_player(s2_0[i],pos1,ang1,s2_1[i]);
      coll = ( (s2_1[i][X]<s1_1[0][X])
	       && (s2_1[i][X]>s1_1[2][X])
	       && (s2_1[i][Y]<s1_1[0][Y])
	       && (s2_1[i][Y]>s1_1[2][Y]));
      if (coll) break;
    }
  }

  return coll;
}


int point_rect_collide(FIXED posp[XY], FIXED posr[XY], ANGLE angr, FIXED lr[XY]){

  FIXED xmin = slMulFX(toFIXED(-0.5),lr[X]);
  FIXED xmax = slMulFX(toFIXED(0.5),lr[X]);
  FIXED ymin = slMulFX(toFIXED(-0.5),lr[Y]);
  FIXED ymax = slMulFX(toFIXED(0.5),lr[Y]);

  FIXED sp_r[XY];
  coord_screen_to_player(posp,posr,angr,sp_r);
  
  if (sp_r[X]<xmin) return 0;
  if (sp_r[X]>xmax) return 0;
  if (sp_r[Y]<ymin) return 0;
  if (sp_r[Y]>ymax) return 0;
  return 1;

}

Sint32 dist_int(int pix, int piy, int pjx, int pjy){
  
  int dist[XY];
  int dmax = 5000;

  dist[X] = pix - pjx;
  dist[Y] = piy - pjy;
  
  if ((dist[X]>(dmax))) return -1;
  if ((dist[X]<(-dmax))) return -1;
  
  if ((dist[Y]>(dmax))) return -1;
  if ((dist[Y]<(-dmax))) return -1;

  Sint32 real = dist[X]*dist[X]+dist[Y]*dist[Y];

  return real;
  
}


