#include "player.h"
#include "bitmap.h"
#include "bomb.h"
#include "random.h"
#include "coll.h"
#include "sound.h"
#include "mitrail.h"
#include "trigolo.h"

extern int p_pad[];
extern TANK_COLOR tank_cols[];

extern PDATA PD_PLANE1;
extern PDATA PD_PLANE2;
extern PDATA PD_PLANE3;
extern PDATA PD_TARGET;

extern ATTR attribute_PLANE1[];
extern ATTR attribute_PLANE2[];
extern ATTR attribute_PLANE3[];
extern ATTR attribute_TARGET[];

extern SPR_ATTR attr[];

PLAYER Players[PLAYER_NUM];

inline int player_is_dead(PLAYER*p){
  return (p->energy<=0);
}

void cipiu_init(CIPIU* c){
  c->to = 0;
  c->action = CIPIU_NOOP;
  c->last_tourne = 0;
  c->tourne_nimp_count =0 ;
  c->last_tourne_tourelle =0;
  c->tourne_tourelle_nimp_count=0;
}

void players_init(){
  int i;
  for (i=0;i<PLAYER_NUM;i++){
    PLAYER* p = &(Players[i]);
    int place_ok;
    do {
      p->pos[X] = minmaxrnd(toFIXED(-100.0),toFIXED(100.0));
      p->pos[Y] = minmaxrnd(toFIXED(-100.0),toFIXED(100.0));
      int j;
      int col =0;
      for (j=0;j<i;j++){
	FIXED l[XY];
	l[X]=toFIXED(TANK_SIZE*1.0);
	l[Y]=toFIXED(TANK_SIZE*0.7);
	//	col = rect_collide(p->pos,p->dir,l,Players[j].pos,Players[j].dir,l);
	col = circle_collide(p->pos,Players[j].pos,toFIXED(2*TANK_SIZE));
	if (col) break;
      }

      place_ok = ((terrain_check_type(p->pos,p->pos))
		  && (terrain_check_borders(p->pos))
		  && (!col));
    } while (!place_ok);
    p->inside = 1;
    p->dir = DEGtoANG(minmaxrnd(toFIXED(-100.0),toFIXED(100.0)));

    p->pad = p_pad[i];
    p->col = i;

    p->fire_dir = 0;
    p->energy=MAX_PLAYER_ENERGY;
    p->presure = -1;
    p->last_presure =BOMB_MAX_PRESURE;
    p->fire_to = TANK_FIRE_TO/2;
    p->hurt = -1;
    p->hurt_by = -1;
    p->is_cipiu = 1;
    p->mitrail_to = TANK_MITRAIL_TO;
    p->mitrail_ammo = INIT_MITRAIL_AMMO;
    p->bomb_ammo = INIT_BOMB_AMMO;
    p->reload_to = 0;
    p->is_infant = 0;
    p->plays = 1;

    cipiu_init(&(p->cipiu));
    
    int ndisp;
    for (ndisp=0;ndisp<i;ndisp++){
      //      player_display(ndisp,1,0);
    }
    //    slSynch();
  }
}

void players_set_next(){
  int i;
  for (i=0;i<PLAYER_NUM;i++) {
    if (Players[i].plays){
      player_set_next(&(Players[i]));
    }
  }
}

void players_display_bound(){
  int i;
  
  FIXED a[XY] = {toFIXED(TANK_SIZE/2.0),toFIXED(TANK_SIZE*0.5*0.7)};
  FIXED b[XY] = {toFIXED(TANK_SIZE/2.0),toFIXED(-TANK_SIZE*0.5*0.7)};
  FIXED c[XY] = {toFIXED(-TANK_SIZE/2.0),toFIXED(TANK_SIZE*0.5*0.7)};
  FIXED d[XY] = {toFIXED(-TANK_SIZE/2.0),toFIXED(-TANK_SIZE*0.5*0.7)};

  for (i=0;i<PLAYER_NUM;i++) {
    PLAYER* p = &(Players[i]);
    FIXED pos[XY];

    coord_player_to_screen(a,p->pos,p->dir,pos);
    bm_pixel_set((pos[X])>>16,(pos[Y])>>16,PAL_PLAYER+i);
    coord_player_to_screen(b,p->pos,p->dir,pos);
    bm_pixel_set((pos[X])>>16,(pos[Y])>>16,PAL_PLAYER+i);
    coord_player_to_screen(c,p->pos,p->dir,pos);
    bm_pixel_set((pos[X])>>16,(pos[Y])>>16,PAL_PLAYER+i);
    coord_player_to_screen(d,p->pos,p->dir,pos);
    bm_pixel_set((pos[X])>>16,(pos[Y])>>16,PAL_PLAYER+i);
  }
}

void bloodify(int x,int y){
  int i;
  for (i=0;i<20;i++){
    int xx = x -6 + minmaxrndint(0,12);
    int yy = y -6 + minmaxrndint(0,12);
    if (i>15){
      bm_pixel_set(xx,yy,PAL_SAND+minmaxrndint(0,PAL_SAND_S-1));
    } else {
      bm_pixel_set(xx,yy,1);
    }
  }
}


void players_check(){
  static int turn=0;

  int i,j;
  for (i=0;i<PLAYER_NUM;i++) {
    int collide = 0;
    if (Players[i].plays){
      for (j=0;j<PLAYER_NUM;j++) {
	if ((i!=j)&&(Players[j].plays)){
	  // calcul de la collision entre le prochain de i et le actuel de j;
	  PLAYER* pi = &(Players[i]);
	  PLAYER* pj = &(Players[j]);

	  collide = circle_collide(pi->n_pos,pj->pos,toFIXED(1.2*TANK_SIZE));
	  
	  if (collide){
	    FIXED l[XY];
	    l[X]=toFIXED(TANK_SIZE*1.0);
	    l[Y]=toFIXED(TANK_SIZE*0.7);
	    collide = rect_collide(pi->n_pos,pi->n_dir,l,pj->pos,pj->dir,l);
	  }
	  if (collide) break;
	  
	  if (pj->is_infant){
	    if (!(pj->infant.dead)){
	      int icollide = circle_collide(pi->n_pos,pj->infant.pos,toFIXED(1.2*TANK_SIZE));
	      if (icollide){
		FIXED l[XY];
		l[X]=toFIXED(TANK_SIZE*1.0);
		l[Y]=toFIXED(TANK_SIZE*0.7);
		
		FIXED li[XY];
		li[X]=toFIXED(5.0);
		li[Y]=toFIXED(5.0);
		
		icollide = rect_collide(pi->n_pos,pi->n_dir,l,pj->infant.pos,pj->infant.ang,li);
	      }
	      if (icollide) {
		pj->infant.dead=1;
		bloodify(pj->infant.pos[X]>>16,pj->infant.pos[Y]>>16);
		sound_tell(vs_b_eau,2);
		break;
	      }
	    }
	  }
	}
      }
      if (!collide){
	if(terrain_check_borders(Players[i].n_pos))
	  if (terrain_check_type(Players[i].pos,Players[i].n_pos))
	    player_set_to_next(&(Players[i]));
      }
    }
  }
}


void player_infants_display(){
  int i;
  static FIXED Z = toFIXED(176.0);
  float superscale = 3.0;
  for (i=0;i<PLAYER_NUM;i++){
    if ((Players[i].plays) && (Players[i].is_infant)){
      if (!(Players[i].infant.dead)){
	attribute_PLANE1[0].colno = tank_cols[Players[i].col].c2;
    
	slPushMatrix(); 
	{
	  slTranslate(Players[i].infant.pos[X],Players[i].infant.pos[Y],Z);
	  slPushMatrix();
	  {
	    slRotZ(Players[i].infant.ang);
	    slScale(toFIXED(1.0*superscale),toFIXED(superscale),toFIXED(1.0));
	    
	    slPutPolygon(&PD_PLANE1);
	  }
	  slPopMatrix();
	}
	slPopMatrix();
      }
    }
  }
}

void players_display(){
  int i;
  for (i=0;i<PLAYER_NUM;i++) {
    if (Players[i].plays)
      player_display(&(Players[i]),1,1);
  }
  player_infants_display();
}




ORDERS Orders;
void orders_init(){
  Orders.avance = 0;
  Orders.tourne = 0;
  Orders.tourne_tourelle = 0;
  Orders.arme = 0;
  Orders.feu = 0;
  Orders.mitrail = 0;
  Orders.suicide = 0;
}

void get_bomb_dest(PLAYER* p,FIXED expl[XY]){
  FIXED coscos = cosinus(p->dir+p->fire_dir);
  FIXED sinsin = sinus(p->dir+p->fire_dir);


  expl[X]  =  p->pos[X] + slMulFX(toFIXED(2.0*p->presure),coscos);
  expl[Y]  =  p->pos[Y] + slMulFX(toFIXED(2.0*p->presure),sinsin);
}

void player_set_next_cipiu(PLAYER* p){

  //  Uint16 pad  = Smpc_Peripheral[p->pad].data;
  Uint16 padp  = Smpc_Peripheral[p->pad].push;

  /*  if (!(padp & PER_DGT_TA)){
    p->is_cipiu = 0;
    return;
  }
  */
  if (p->cipiu.action != CIPIU_NOOP){
    if ((p->cipiu.action == CIPIU_GO)||(p->cipiu.action == CIPIU_GO_R)){
      Orders.avance = 1;
    } 
    if (p->cipiu.action == CIPIU_LEAVE){
      Orders.avance = -1;
    } 
  }
  
  if (p->cipiu.to == 0){
    int cible;

    if ((p->hurt_by != -1)&&(minmaxrndint(0,100)>10)) {
      cible = p->hurt_by;
    } else {
      cible = minmaxrndint(0,100)%PLAYER_NUM;
    }

    p->cipiu.to = minmaxrndint(200,400);
      
    if (Players[cible].plays==0){
      p->cipiu.to = 1;
    } else if (player_is_dead(&(Players[cible]))){
      p->cipiu.to = 1;
    } else {
      p->cipiu.target = Players[cible].pos;    
      p->cipiu.action = minmaxrndint(0,500)%6;   
    } 
    
    if (&(Players[cible]) == p) {
      p->cipiu.to = minmaxrndint(1,10);
      p->hurt_by = -1;
    } 
	

  } else {
    p->cipiu.to -= 1;
  }


  FIXED res[XY];

  if (p->cipiu.action != CIPIU_NOOP){
    
    coord_screen_to_player(p->cipiu.target,p->pos,p->dir,res);  
    if (p->cipiu.action != CIPIU_GO_R){
      if (res[Y]>0) {  
	Orders.tourne = 1;
      } else {
	Orders.tourne = -1;
      }
    }
  }
  coord_screen_to_player(p->cipiu.target,p->pos,p->dir+p->fire_dir,res);  
  if (res[Y]>0) {  
    Orders.tourne_tourelle = 1;
  } else {
    Orders.tourne_tourelle = -1;
  }
  
  CIPIU* c = &(p->cipiu);
  if (c->last_tourne!=0) {
    if (c->last_tourne + Orders.tourne){
      c->tourne_nimp_count += 1;    
    }
    if (c->tourne_nimp_count>1) {
      Orders.tourne = 0;
      c->tourne_nimp_count = 0;  
    }
  }

  if (c->last_tourne_tourelle!=0) {
    if (c->last_tourne_tourelle + Orders.tourne_tourelle){
      c->tourne_tourelle_nimp_count += 1;    
    }
    if (c->tourne_tourelle_nimp_count>1) {
      Orders.tourne_tourelle = 0;
      c->tourne_tourelle_nimp_count = 0;  
    }
  }

  c->last_tourne = Orders.tourne;
  c->last_tourne_tourelle =Orders.tourne_tourelle;


  if ((minmaxrndint(0,800)>300)){
    Orders.arme = 1;
  }
  if ((minmaxrndint(0,800)>790)){
    Orders.mitrail = 1;
  }
  
  if (circle_collide(p->cipiu.target,p->cache.bomb_dest,toFIXED(5.0))){
    Orders.feu = 1;
  }

}


void player_set_next_human(PLAYER* p){
    

  Uint16 pad  = Smpc_Peripheral[p->pad].data;
  Uint16 padp  = Smpc_Peripheral[p->pad].push;
  Uint16 padpul  = Smpc_Peripheral[p->pad].pull;

  FIXED mov  = toFIXED(0.2);
  FIXED movd = toFIXED(0.15);
    


  if (!(pad & PER_DGT_ST)){
    p->is_cipiu = 1;
    return;
  }

  if ((!(pad & PER_DGT_TA))&&(!(pad & PER_DGT_TB))&&(!(pad & PER_DGT_TC)))
    Orders.suicide = 1;

  if (!(p->is_infant)){
    if (!(pad & PER_DGT_KL)) Orders.tourne = -1; 
    if (!(pad & PER_DGT_KR)) Orders.tourne = 1; 
    if (!(pad & PER_DGT_KU)) Orders.avance =  1;
    if (!(pad & PER_DGT_KD)) Orders.avance =  -1;
    if (!(pad & PER_DGT_TX)) Orders.tourne_tourelle = -1; 
    if (!(pad & PER_DGT_TY)) Orders.tourne_tourelle = 1; 

    // tir
    if (!(padp & PER_DGT_TA)) {
      Orders.arme = 1;
    }
    
    if (!(padpul & PER_DGT_TA)){
      Orders.feu = 1;
    }

    /*    if (!(padp & PER_DGT_TB)) {
      Orders.arme = 1;
    } else if (!(pad & PER_DGT_TB)) {
      if (p->presure >= p->last_presure)
	Orders.feu = 1;
    }
    */
  }

  if (p->is_infant){

    if (p->infant.dead) return;

    int l,r,u,d;
    FIXED dx,dy;
    dx = dy = toFIXED(0.0);
    ANGLE ang;

    ang = p->infant.ang;
    
    l = (!(pad & PER_DGT_KL));
    r = (!(pad & PER_DGT_KR));
    u = (!(pad & PER_DGT_KU));
    d = (!(pad & PER_DGT_KD));
    
    if (u){
      if (l){
	ang = DEGtoANG(-45.0);
	dx = -movd; dy = -movd;
      } else if (r){
	ang = DEGtoANG(45.0);
	dx = +movd; dy = -movd;
      } else {
	ang = DEGtoANG(0.0);
	dy = -mov;
      }
    } else if (d){
      if (l){
	ang = DEGtoANG(-135.0);
	dx = -movd; dy = movd;
      } else if (r){
	ang = DEGtoANG(135.0);
	dx = +movd; dy = movd;
      } else {
	ang = DEGtoANG(180.0);
	dy += mov;
      }
    } else if (l){
      ang = DEGtoANG(-90.0);
      dx = -mov; 
    } else if (r){
      ang = DEGtoANG(90.0);
      dx = +mov; 
    }
    p->infant.ang = ang;    
    p->infant.pos[X]+=dx;
    p->infant.pos[Y]+=dy;
  }


  if (!(padp & PER_DGT_TZ)){
    if (!(p->is_infant)){
      p->infant.pos[X] = p->pos[X];
      p->infant.pos[Y] = p->pos[Y];
      p->infant.dead = 0;
      p->is_infant = 1;
    } else if (circle_collide(p->pos,p->infant.pos,toFIXED(0.8*TANK_SIZE))){
      p->is_infant = 0;
    }
  }

  if(!(pad & PER_DGT_TC)) {
    Orders.mitrail = 1;
  }


}

void player_set_next(PLAYER* p){

  // don't move if nothing happens
  p->n_dir = p->dir;
  p->n_pos[X] = p->pos[X];
  p->n_pos[Y] = p->pos[Y];

  // step 
  if (p->fire_to>0)
    p->fire_to--;
  if (p->hurt>=0)
    p->hurt-=1;

  if (p->mitrail_to>0){
    p->mitrail_to--;
  }


  p->reload_to++;
  
  if (!((p->reload_to)%120)){
    p->mitrail_ammo+=1;
    if (p->mitrail_ammo>MAX_MITRAIL_AMMO) 
      p->mitrail_ammo = MAX_MITRAIL_AMMO;
  }
  
  if (!((p->reload_to)%300)){
    p->bomb_ammo+=1;
    if (p->bomb_ammo>MAX_BOMB_AMMO) 
      p->bomb_ammo = MAX_BOMB_AMMO;
  }
  

  // cache 
  
  get_bomb_dest(p,p->cache.bomb_dest);

  orders_init();

  if (p->is_cipiu){
    player_set_next_cipiu(p);
  } else {
    player_set_next_human(p);
  }
  if (p->energy>0){
    if (Orders.suicide){
      int i;
      FIXED dist = toFIXED(10.0);
      ANGLE ang = p->dir;
      
      for (i=0;i<12;i++){
	dist+=toFIXED(4.0);
	ang += DEGtoANG(50.0);
	FIXED src[XY];
	src[X]  =  p->pos[X] + slMulFX(dist,cosinus(ang));
	src[Y]  =  p->pos[Y] + slMulFX(dist,sinus(ang));      
	bomb_fire(30+2*i,src,p->pos,p->col);
      }
    }
  }
    FIXED av = toFIXED(TANK_AV_S);


  // tank
  if (p->energy>100){
    if (Orders.tourne==1)  p->n_dir = p->dir + DEGtoANG(TANK_ANG_S);
    if (Orders.tourne==-1)  p->n_dir = p->dir + DEGtoANG(-TANK_ANG_S);
    if (Orders.avance==1) {
      p->n_pos[X] = p->pos[X] + slMulFX(av,cosinus(p->dir));
      p->n_pos[Y] = p->pos[Y] + slMulFX(av,sinus(p->dir));
    }
    if (Orders.avance==-1) {
      p->n_pos[X] = p->pos[X] - slMulFX(av,cosinus(p->dir));
      p->n_pos[Y] = p->pos[Y] - slMulFX(av,sinus(p->dir));
    }
  }

  if (p->energy>1){
    if ((Orders.mitrail)&&(p->mitrail_to<=0)&&(p->mitrail_ammo>0)){

      p->mitrail_to = TANK_MITRAIL_TO;
      
      if (p->is_infant){
	mitrail_fire(p->infant.pos,(p->infant.ang)-DEGtoANG(90.0));
      } else {
	mitrail_fire(p->pos,p->dir);
      }
      
      p->mitrail_ammo -= 1;
      if (p->mitrail_ammo <=0){
	p->mitrail_ammo = 0;
      }
    }
  }


  // tourelle 
  if (p->energy>50){
    if (Orders.tourne_tourelle == 1) p->fire_dir += DEGtoANG(TANK_T_ANG_S);
    if (Orders.tourne_tourelle == -1) p->fire_dir += DEGtoANG(-TANK_T_ANG_S);
  }




  int bomb_now=0;

  if (p->energy>0){   
    if (p->presure>0){  // armé
      if ((Orders.feu)||(p->presure>BOMB_MAX_PRESURE)){ // feu
	bomb_now = 1;
      } else {
	p->presure +=1;
      }
    } else {            // non armé
      if ((Orders.arme)&&(p->fire_to==0)&&( p->bomb_ammo>0)){
	p->presure = 1;
      }
    }
  }

  if (bomb_now)    {
    p->bomb_ammo -= 1;
    if (p->bomb_ammo <=0){
      p->bomb_ammo = 0;
    }
   
    FIXED expl[XY];
    get_bomb_dest(p,expl);
    FIXED src[XY];
    src[X]  =  p->pos[X] + slMulFX(toFIXED(10.0),cosinus(p->dir+p->fire_dir));
    src[Y]  =  p->pos[Y] + slMulFX(toFIXED(10.0),sinus(p->dir+p->fire_dir));

    bomb_fire(p->presure,src,p->cache.bomb_dest,p->col);

    p->fire_to = TANK_FIRE_TO;
    p->last_presure=p->presure;
    p->presure=0;
  }
}

void player_set_to_next(PLAYER* p){
  p->pos[X] = p->n_pos[X];
  p->pos[Y] = p->n_pos[Y];
  p->dir = p->n_dir;
}

void players_display_energy(){
  int i;
  for (i=0;i<PLAYER_NUM;i++){
    int xmargin = 20;
    int DX = xmargin-X_MAX/2;
    int DY = 5-Y_MAX/2;
    int l = (X_MAX - xmargin*2)/6;     
    if (Players[i].plays){
      
      int x  = DX + (i%6)*l;
      int y = DY + (i/6)*15;
      slBMBoxFill(x,y,x+l*3/4,y+3,PAL_T);
      if (Players[i].energy>0)
	slBMBoxFill(x,y,x+l*Players[i].energy/(MAX_PLAYER_ENERGY)*3/4,y+3,PAL_PLAYER+i);    
      //    if (Players[i].fire_to!=-1)
      //      slBMBoxFill(x,y+3,x+l*Players[i].fire_to/TANK_FIRE_TO*3/4,y+3,0);    
    }
  }
}

void players_display_ammo(){
  int i;

  int xmargin = 20;
  int DX = xmargin-X_MAX/2;
  int DY = 10-Y_MAX/2;
  int l = (X_MAX - xmargin*2)/6;     
  for (i=0;i<PLAYER_NUM;i++){
    if (Players[i].plays){
      int x  = DX + (i%6)*l;
      int y = DY + (i/6)*8;
      
      slBMBoxFill(x,y,x+l*3/4,y,PAL_T);
      if (Players[i].bomb_ammo>0)
	slBMBoxFill(x,y,x+l*Players[i].bomb_ammo/(MAX_BOMB_AMMO)*3/4,y,PAL_PLAYER+i);    
    }
  }
      

  DY = 12-Y_MAX/2;
  for (i=0;i<PLAYER_NUM;i++){
    if (Players[i].plays){
      int x  = DX + (i%6)*l;
      int y  = DY + (i/6)*8;
      slBMBoxFill(x,y,x+l*3/4,y,PAL_T);
      if (Players[i].mitrail_ammo>0)
	slBMBoxFill(x,y,x+l*Players[i].mitrail_ammo/(MAX_MITRAIL_AMMO)*3/4,y,PAL_PLAYER+i);    
      
      //    if (Players[i].fire_to!=-1)
      //      slBMBoxFill(x,y+3,x+l*Players[i].fire_to/TANK_FIRE_TO*3/4,y+3,0);    
    }
  }
}


void player_display_debris(FIXED debris[XY],FIXED ray,int col){
  int i;
  static ANGLE ang = 0;
  ang += slRandom();

  for (i=0;i<1;i++){
    ray = toFIXED(7.0)+slMulFX(minmaxrnd(toFIXED(0.0),toFIXED(1.3)),ray);
    int x = (debris[X] + slMulFX(ray,cosinus(ang)))>>16;
    int y = (debris[Y] + slMulFX(ray,sinus(ang)))>>16;


    //    int x = debris[X] -20 + minmaxrndint(0,40);
    //    int y = debris[Y] -20 + minmaxrndint(0,40);
    bm_pixel_set(x,y,PAL_PLAYER+col);
  }
}


void player_display_canon_fire(FIXED pos[XY],float tperc){
  int i;
  for (i=0;i<5;i++){
    int x = (pos[X]>>16) - 4 + minmaxrndint(0,8);
    int y = (pos[Y]>>16) - 4 + minmaxrndint(0,8);
    Uint8 col = PAL_FUMEE + minmaxrndint(0,PAL_FUMEE_S);
    //    bm_pixel_set(x,y,col);

    bm_pixel_set2(x,y,col);
  }
}

void player_display_target(PLAYER* p){

  attribute_TARGET[0].colno = tank_cols[p->col].c1;
  slPushMatrix(); 
  {
    slTranslate(p->cache.bomb_dest[X],p->cache.bomb_dest[Y],toFIXED(170.0));
    slPushMatrix(); 
    {
      slScale(toFIXED(4.0),toFIXED(4.0),toFIXED(1.0));
      slRotZ(DEGtoANG(0.0));
      slPutPolygon(&PD_TARGET);
    }
    slPopMatrix();
  }
  slPopMatrix();
  
}

void player_display(PLAYER* p,int superscale, int ornements){

  FIXED scale;

  static FIXED Z = toFIXED(176.0);
  /*
    Uint16 pad  = Smpc_Peripheral[p->pad].push;
    if (!(pad & PER_DGT_TZ)){
    Z -= toFIXED(1.0);
    }
  */
  
  scale = toFIXED(10.0);

  if (ornements){
    FIXED trx,try;
    FIXED larg = toFIXED(TANK_SIZE/2.0*0.5);
    
    trx = slMulFX(larg,-sinus(p->dir));
    try = slMulFX(larg,cosinus(p->dir));
    
    bm_pixel_set((int)((p->pos[X]+trx)>>16),
			 (int)((p->pos[Y]+try)>>16),PAL_T+minmaxrndint(0,PAL_T/2));
    
    trx = slMulFX(larg,sinus(p->dir));
    try = slMulFX(larg,-cosinus(p->dir));
    
    bm_pixel_set((int)((p->pos[X]+trx)>>16),
			 (int)((p->pos[Y]+try)>>16),PAL_T+minmaxrndint(0,PAL_T/2));
  }

  if (p->energy>0){
    attribute_PLANE1[0].colno = tank_cols[p->col].c1;
    attribute_PLANE2[0].colno = tank_cols[p->col].c2;
    if (p->fire_to == 0)      
      attribute_PLANE3[0].colno = tank_cols[p->col].c3;
    else 
      attribute_PLANE3[0].colno = tank_cols[p->col].c5;
  } else {
    attribute_PLANE1[0].colno = tank_cols[p->col].c4;
    attribute_PLANE2[0].colno = tank_cols[p->col].c4;
    attribute_PLANE3[0].colno = tank_cols[p->col].c4;
  }
  slPushMatrix(); 
  {
    slTranslate(p->pos[X],p->pos[Y],Z);
    slPushMatrix();
    {
      slPushMatrix();
      {
	slRotZ(p->dir);
	slScale(toFIXED(TANK_SIZE*1.0*superscale),toFIXED(TANK_SIZE*1.0*superscale),toFIXED(1.0));

	// roues 
	slPushMatrix();
	{
	  slScale(toFIXED(1.0),toFIXED(0.7),scale);	
	  slPutPolygon(&PD_PLANE1);
	}
	slPopMatrix();
	
	// centre
	slPushMatrix();
	{
	  slScale(toFIXED(1.0),toFIXED(0.3),scale);	
	  slPutPolygon(&PD_PLANE2);
	}
	slPopMatrix();
	
	// tourelle
	slPushMatrix();
	{
	  slTranslate(toFIXED(-0.1),toFIXED(0.0),toFIXED(0.0));
	  slPushMatrix();
	  {
	    slScale(toFIXED(0.4),toFIXED(0.4),scale);	
	    slPutPolygon(&PD_PLANE3);
	  }
	  slPopMatrix();
	}
	slPopMatrix();

	//canon
	slPushMatrix();
	{
	  slRotZ(p->fire_dir);
	  slPushMatrix();
	  {
	    slTranslate(toFIXED(0.3),toFIXED(0.0),toFIXED(-1.0));
	    slPushMatrix();
	    {
	      slScale(toFIXED(0.6),toFIXED(0.15),scale);	
	      slPutPolygon(&PD_PLANE3);
	    }
	    slPopMatrix();
	  }
	  slPopMatrix();
	}
	slPopMatrix();
      }
      slPopMatrix();
    }
    slPopMatrix();
  }
  slPopMatrix();

  if (ornements){

    int tdisp = 10;
    if ((TANK_FIRE_TO-p->fire_to)<tdisp){
      FIXED expl[XY];
      
      expl[X]  =  p->pos[X] + slMulFX(toFIXED(10.0+1.0*tdisp),cosinus(p->dir+p->fire_dir));
      expl[Y]  =  p->pos[Y] + slMulFX(toFIXED(10.0+1.0*tdisp),sinus(p->dir+p->fire_dir));
      
      player_display_canon_fire(expl,1.0*(TANK_FIRE_TO-p->fire_to)/tdisp);
    }
    
    if (p->hurt!=-1){
      FIXED ray = slMulFX(toFIXED(1.0),slSquartFX(toFIXED(1.0*p->hurt)));
      player_display_debris(p->pos,ray,p->col);
    }
    
    if ((p->presure>0)&&(!p->is_cipiu))
      player_display_target(p);
  }
}

