#include "sgl.h"

#define TANK_FIRE_TO 80
#define TANK_ANG_S    3.0 // tank angle change
#define TANK_T_ANG_S  1.5 // tourelle angle change
#define TANK_AV_S     0.3 // tank speed
//#define TANK_AV_S     3 // tank speed

#define TANK_MITRAIL_TO 5

#define PLAYER_NUM 6

#define CIPIU_NOOP   0
#define CIPIU_GO     1
#define CIPIU_LEAVE  2
#define CIPIU_ROTATE 3
#define CIPIU_GO_R   5

#define TANK_SIZE 13

#define MAX_MITRAIL_AMMO 30
#define INIT_MITRAIL_AMMO 30
#define MAX_BOMB_AMMO    20
#define INIT_BOMB_AMMO    6

typedef struct {
  int to;
  FIXED* target;
  int action;
  int last_tourne;
  int tourne_nimp_count;
  int last_tourne_tourelle;
  int tourne_tourelle_nimp_count;
} CIPIU;

typedef struct {
  FIXED bomb_dest[XY];
} PLAYER_CACHE;

#define MAX_PLAYER_ENERGY 800

typedef struct {
  FIXED pos[XY];
  ANGLE ang;
  int dead;
} INFANT;

typedef struct {
  int inside;
  FIXED pos[XY];
  ANGLE dir;
  FIXED n_pos[XY];
  ANGLE n_dir;
  ANGLE fire_dir;
  int presure;
  int last_presure;
  int col;
  int pad;
  int energy;
  int fire_to;
  int hurt;
  int hurt_by;
  int is_cipiu;
  int plays;
  int mitrail_to;
  
  int mitrail_ammo;
  int bomb_ammo;
  int reload_to;

  int is_infant;
  CIPIU cipiu;
  INFANT infant;
  PLAYER_CACHE cache;
} PLAYER;


inline int player_is_dead(PLAYER*p);
void cipiu_init(CIPIU* c);
void players_init();
void players_set_next();
void players_display_bound();
void players_check();
void players_display();

typedef struct {
  int avance;
  int tourne;
  int tourne_tourelle;
  int arme;
  int feu;
  int mitrail;
  int suicide;
} ORDERS;


void orders_init();
void get_bomb_dest(PLAYER* p,FIXED expl[XY]);
void player_set_next_cipiu(PLAYER* p);
void player_set_next_human(PLAYER* p);
void player_set_next(PLAYER* p);
void player_set_to_next(PLAYER* p);
void players_display_energy();
void player_display_debris(FIXED debris[XY],FIXED ray,int col);
void player_display_canon_fire(FIXED pos[XY],float tperc);
void player_display_target(PLAYER* p);
void player_display (PLAYER* p,int superscale,int ornement);



